'placed in the Public Domain 5/24/97 John E. Carter
'johnecarter@mindspring.com
'
'requires PowerBasic 2.1 or higher to compile
'
'motd.bas - generates motd message for PC's - like UNIX(tm) motd.
'Called with no options, it prints the date, the contents of \etc\motd
'(if it exists), and the current date's reminders from \etc\dates (if any).
'Local text can be included by creating directory \etc and putting
'your local text in \etc\motd.
'The text in \etc\motd will automatically be centered when printed.
'If you want to format the text in \etc\motd yourself, use the "c"
'option to turn off centering.
'Called with "v" option, it prints the version number.

'version 1.2 11/03/88
'version 1.3 11/27/89 - added use of "\etc\dates" file for daily reminders
'version 1.4 01/06/90 - added check for tomorrow
'version 1.5 01/15/90 - added check for day after tomorrow, corrected bug in
'			current date check, changed print format
'version 1.6 01/27/90 - separated "file not found" and "path not found" error
'                       checking to determine if "\etc" exists
'version 1.7 01/28/90 - changed reminder code to read contents of \etc\dates
'                       into a dynamic array to speed searches - tested to 1056
'                       entries in \etc\dates
'version 1.8 02/27/90 - added check for February 27 in non-leap years to
'		        nextdate() in motd.inc (2/27 should display 0301 data
'                       in 'future' area)
'version 1.9 05/09/90 - added PowerBASIC metastatements to control compile
'version 1.10 01/21/91 - added command line date option
'version 1.11 08/29/91 - extended future dates to 5 days beyond start date
'version 1.11a 05/24/93 - added array sort of messages
'numbered REM lines are for debugging 
'setup
$LIB COM OFF, GRAPH OFF
$COMPILE EXE
10 rem
defint a-z
dim mth$(12)
dim day$(7)
dim maxdays(12)
dim test$(5)
dim startest$(5)
SHARED thisday$
on error goto errchk

'define constants
version$="@(#) motd - version 1.11a - 930524 (John E. Carter)"

'table of month names
mth$(1)="January"
mth$(2)="February"
mth$(3)="March"
mth$(4)="April"
mth$(5)="May"
mth$(6)="June"
mth$(7)="July"
mth$(8)="August"
mth$(9)="September"
mth$(10)="October"
mth$(11)="November"
mth$(12)="December"

'table of day names
day$(0)="Sunday"
day$(1)="Monday"
day$(2)="Tuesday"
day$(3)="Wednesday"
day$(4)="Thursday"
day$(5)="Friday"
day$(6)="Saturday"

'table of month sizes
maxdays(1) = 31
maxdays(2) = 28
maxdays(3) = 31
maxdays(4) = 30
maxdays(5) = 31
maxdays(6) = 30
maxdays(7) = 31
maxdays(8) = 31
maxdays(9) = 30
maxdays(10) = 31
maxdays(11) = 30
maxdays(12) = 31

'standard messages
'put your choice of text (Proprietary, Private, Welcome, whatever) into
'the following strings if you want to imbed the text in the program
hdr1$=""
hdr2$=""
hdr3$=""
hdr4$=""

'initialize some variables
dloc = 0
month = 0
cx=0
res=0
notdir=0
lincount=0
drive%=0
curdriv%=0
prevdir$=space$(65)

'start with a clean screen
cls

'find where we are - not used when all files in \etc
'call GetDir(curdriv%,prevdir$)
'massage it to a "real" directory specification
'sploc = instr(prevdir$,"\")
'if sploc > 0 then prevdir$ = "\" + left$(prevdir$,sploc - 1)

'check for command line options
20 rem
ucom$ = ucase$(command$)
if instr(ucom$,"C")<>0 then incr cx
if instr(ucom$,"E")<>0 then incr edt
if instr(ucom$,"V")<>0 then print version$:end
if instr(ucom$,"D")<>0 then
  dloc = instr(ucom$,"D")
  if len(right$(ucom$,len(ucom$) - dloc)) = 4 then
    cmonth$ = mid$(ucom$,dloc+1,2)
    cday$ = mid$(ucom$,dloc+3,2)
   else
     print
     print "Invalid date entered.  Must be four digit month and day: MMDD"
     end
   end if
end if

30 rem
cls					'clear screen
call getdate                            'get month, day, day of week
month = reg(%dx) \ 256
dayofweek=(reg(%ax) and &hff)
daynum=(reg(%dx) and &hff)
year=reg(%cx)
day$=mid$(date$,4,2)
daynum$=day$
if left$(day$,1)="0" then day$=right$(day$,1)	'print "1", not "01"
year$=str$(year)
thisday$="Today is "+day$(dayofweek)+", "+mth$(month)+" "+day$+","+year$+"."
call nextdate(year,month,daynum,test$(),startest$(),maxdays())

40 rem
if edt then
  call editdata
else
  'print standard message
  print
  if hdr1$ <> "" then call center(hdr1$)
  if hdr1$ <> "" then call center(hdr2$)
  if hdr1$ <> "" then call center(hdr3$)
  if hdr1$ <> "" then call center(hdr4$)


50 rem
'print local message (if any)
  if dloc = 0 then
    opnfile$="\etc\motd"
    k$ = dir$(opnfile$)
    if len(k$) > 0 then
      open opnfile$ for input as 1
      while eof(1)<>-1
	line input #1,x$
	if cx=0 then call center(x$) else print x$
      wend
      close 1
    end if
  end if

60 rem
TODAY:
  if dloc = 0 then
    call center(thisday$)
    print
    if notdir = 1 then goto 9999
  end if

70 rem
THISDATE:
  'Check here for \etc\dates file - if present, check for message for this date
  '\etc\dates is in MMDD:message_of_the_day format
  'Starting an entry in \etc\dates with a non-numeric (other than '**') makes it a comment
  opnfile$="\etc\dates"
  if dloc = 0 then
    mt$=right$(str$(month),len(str$(month))-1)
    if len(mt$)=1 then mt$="0" + mt$
    chk$=right$(mt$ + daynum$,4)              'this month and day
  else
    chk$ = cmonth$ + cday$
  end if
72 rem
  starchk$ = "**" + right$(chk$,2)          'any month and this day
  dayfound=0
  'read file to get number of lines
  k$ = dir$(opnfile$)
  if len(k$) > 0 then
    open opnfile$ for input as 1
    while not eof(1)
      line input #1, x$
      incr lincount
    wend
    close 1
  'dimension array to hold that many (+1 because msg$(0) not used)
74 rem
    dim msg$(lincount + 1)
    lincount = 1
  'read in the reminder lines
    open opnfile$ for input as 1
    while not eof(1)
      line input #1, msg$(lincount)
      incr lincount
    wend
    close 1
    array sort msg$()  'added 5/25/93
76 rem
  'check for today's messages
    for msgline = 1 to lincount
      mchk$ = left$(msg$(msgline),4)
      if mchk$ = chk$ or mchk$ = starchk$ then
	if dayfound = 0 then
	  if dloc = 0 then
	    call center("Reminders for today"):print
	  else
	    call center("Reminders for "+chk$):print
	  end if
	  incr dayfound
	end if
	if instr(msg$(msgline),chr$(7)) > 0 then beep
	print right$(msg$(msgline),len(msg$(msgline))-5)
      end if
    next msgline
78 rem
  'check for tomorrow and the day after
    if dayfound <> 0 then print:dayfound=0
    for msgline = 1 to lincount
      fc$ = left$(msg$(msgline),4)
      for nxtday = 1 to 5
	if fc$ = test$(nxtday) or fc$ = startest$(nxtday) then
	  if dayfound = 0 then call center("Reminders for future dates"):print
	  incr dayfound
	  if instr(msg$(msgline), chr$(7)) > 0 then beep
	  print msg$(msgline)
	end if
      next nxtday
    next msgline
  end if
  goto 9999

  'check for 'path not found' and 'file not found' errors
80 rem
errchk:
  if err = 53 or err = 76 then
    if opnfile$="\etc\motd" then resume TODAY
    if opnfile$="\etc\dates" then resume 9999
  else
    print "error number ";err;" encountered at line ";erl;".  Program terminated"
  end if

  9999 system
end if  'if edt

$include "regnames.inc"
$include "motd.inc"
